package com.friday.distributor.po;

import com.friday.base.common.utils.DataConvertUtil;
import com.friday.distributor.constant.States;
import com.friday.operation.api.distributor.dto.TaieJobDto;
import com.friday.blank.api.constants.BusinessTypeEnum;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.LocalDateTime;

/**
 * @Author YaoYao
 * @Date Created In 17:33 2023/2/27
 * @Description
 * @Modified By
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class JobInvoke {
    /**
     * 主键ID
     */
    private Integer id;
    /**
     * TAIE用户租户key
     */
    private String taieTenant;
    /**
     * 任务业务类型唯一标志
     */
    private String taskType;
    /**
     * 任务类型{@link BusinessTypeEnum}
     */
    private String bizType;
    /**
     * 任务执行记录uuid
     */
    private String taskId;
    /**
     * 实际执行任务id
     */
    private String execJobId;
    /**
     * 实际执行taie工位
     */
    private String execTaieRobot;
    /**
     * 子任务开始时间
     */
    private LocalDateTime startTime;
    /**
     * 子任务结束时间
     */
    private LocalDateTime endTime;
    /**
     * 子任务级入参
     */
    private String jobInput;
    /**
     * 子任务级出参
     */
    private String jobOutput;
    /**
     * 子任务级业务参数
     */
    private String jobBizData;
    /**
     * 子任务状态
     * {@link States.JobState}
     */
    private String jobState;
    /**
     * 执行失败原因
     */
    private String failMsg;
    /**
     * 是否有效
     */
    private Boolean valid;
    /**
     * 备注
     */
    private String remark;
    /**
     * 创建时间
     */
    private LocalDateTime createTime;
    /**
     * 更新时间
     */
    private LocalDateTime updateTime;

    public TaieJobDto transferToTaieJobDto(){
        return TaieJobDto.builder()
                .taieTenant(taieTenant)
                .bizType(bizType)
                .taskType(taskType)
                .taskId(taskId)
                .invokeId(id)
                .execJobId(execJobId)
                .execTaieRobot(execTaieRobot)
                .jobInput(jobInput)
                .jobOutput(jobOutput)
                .jobBizData(jobBizData)
                .jobState(jobState)
                .startTime(DataConvertUtil.localDateTimeToString(startTime))
                .endTime(DataConvertUtil.localDateTimeToString(endTime))
                .failMsg(failMsg)
                .build();
    }
}
